/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x101408, CODE_FOR_extendqidi2 },
  { 0x101808, CODE_FOR_extendhidi2 },
  { 0x101c08, CODE_FOR_extendsidi2 },
  { 0x10741e, CODE_FOR_extendsfdf2 },
  { 0x10741f, CODE_FOR_extendsfxf2 },
  { 0x107420, CODE_FOR_extendsfrf2 },
  { 0x10781f, CODE_FOR_extenddfxf2 },
  { 0x107820, CODE_FOR_extenddfrf2 },
  { 0x107c20, CODE_FOR_extendxfrf2 },
  { 0x20781d, CODE_FOR_truncdfsf2 },
  { 0x207c1d, CODE_FOR_truncxfsf2 },
  { 0x207c1e, CODE_FOR_truncxfdf2 },
  { 0x20801d, CODE_FOR_truncrfsf2 },
  { 0x20801e, CODE_FOR_truncrfdf2 },
  { 0x20801f, CODE_FOR_truncrfxf2 },
  { 0x301408, CODE_FOR_zero_extendqidi2 },
  { 0x301808, CODE_FOR_zero_extendhidi2 },
  { 0x301c08, CODE_FOR_zero_extendsidi2 },
  { 0x60201f, CODE_FOR_floatdixf2 },
  { 0x602020, CODE_FOR_floatdirf2 },
  { 0x70201d, CODE_FOR_floatunsdisf2 },
  { 0x70201e, CODE_FOR_floatunsdidf2 },
  { 0x70201f, CODE_FOR_floatunsdixf2 },
  { 0x702020, CODE_FOR_floatunsdirf2 },
  { 0x1007408, CODE_FOR_fix_truncsfdi2 },
  { 0x1007808, CODE_FOR_fix_truncdfdi2 },
  { 0x1007c08, CODE_FOR_fix_truncxfdi2 },
  { 0x1008008, CODE_FOR_fix_truncrfdi2 },
  { 0x1107408, CODE_FOR_fixuns_truncsfdi2 },
  { 0x1107808, CODE_FOR_fixuns_truncdfdi2 },
  { 0x1107c08, CODE_FOR_fixuns_truncxfdi2 },
  { 0x1108008, CODE_FOR_fixuns_truncrfdi2 },
  { 0x1202009, CODE_FOR_mulditi3 },
  { 0x1302009, CODE_FOR_umulditi3 },
  { 0x230c832, CODE_FOR_vcondv8qiv8qi },
  { 0x230cc33, CODE_FOR_vcondv4hiv4hi },
  { 0x230d034, CODE_FOR_vcondv2siv2si },
  { 0x230e038, CODE_FOR_vcondv2sfv2sf },
  { 0x240c832, CODE_FOR_vconduv8qiv8qi },
  { 0x240cc33, CODE_FOR_vconduv4hiv4hi },
  { 0x240d034, CODE_FOR_vconduv2siv2si },
  { 0x3407438, CODE_FOR_vec_extractv2sfsf },
  { 0x3501c34, CODE_FOR_vec_initv2sisi },
  { 0x3507438, CODE_FOR_vec_initv2sfsf },
  { 0x3700007, CODE_FOR_addsi3 },
  { 0x3700008, CODE_FOR_adddi3 },
  { 0x3700009, CODE_FOR_addti3 },
  { 0x370001d, CODE_FOR_addsf3 },
  { 0x370001e, CODE_FOR_adddf3 },
  { 0x370001f, CODE_FOR_addxf3 },
  { 0x3700032, CODE_FOR_addv8qi3 },
  { 0x3700033, CODE_FOR_addv4hi3 },
  { 0x3700034, CODE_FOR_addv2si3 },
  { 0x3700038, CODE_FOR_addv2sf3 },
  { 0x3b00007, CODE_FOR_subsi3 },
  { 0x3b00008, CODE_FOR_subdi3 },
  { 0x3b00009, CODE_FOR_subti3 },
  { 0x3b0001d, CODE_FOR_subsf3 },
  { 0x3b0001e, CODE_FOR_subdf3 },
  { 0x3b0001f, CODE_FOR_subxf3 },
  { 0x3b00032, CODE_FOR_subv8qi3 },
  { 0x3b00033, CODE_FOR_subv4hi3 },
  { 0x3b00034, CODE_FOR_subv2si3 },
  { 0x3b00038, CODE_FOR_subv2sf3 },
  { 0x3f00006, CODE_FOR_mulhi3 },
  { 0x3f00007, CODE_FOR_mulsi3 },
  { 0x3f00008, CODE_FOR_muldi3 },
  { 0x3f0001d, CODE_FOR_mulsf3 },
  { 0x3f0001e, CODE_FOR_muldf3 },
  { 0x3f0001f, CODE_FOR_mulxf3 },
  { 0x3f00032, CODE_FOR_mulv8qi3 },
  { 0x3f00033, CODE_FOR_mulv4hi3 },
  { 0x3f00034, CODE_FOR_mulv2si3 },
  { 0x3f00038, CODE_FOR_mulv2sf3 },
  { 0x4300007, CODE_FOR_divsi3 },
  { 0x4300008, CODE_FOR_divdi3 },
  { 0x430001d, CODE_FOR_divsf3 },
  { 0x430001e, CODE_FOR_divdf3 },
  { 0x430001f, CODE_FOR_divxf3 },
  { 0x4600007, CODE_FOR_udivsi3 },
  { 0x4600008, CODE_FOR_udivdi3 },
  { 0x4a00007, CODE_FOR_modsi3 },
  { 0x4a00008, CODE_FOR_moddi3 },
  { 0x4b00007, CODE_FOR_umodsi3 },
  { 0x4b00008, CODE_FOR_umoddi3 },
  { 0x4d00004, CODE_FOR_andbi3 },
  { 0x4d00008, CODE_FOR_anddi3 },
  { 0x4d00032, CODE_FOR_andv8qi3 },
  { 0x4d00033, CODE_FOR_andv4hi3 },
  { 0x4d00034, CODE_FOR_andv2si3 },
  { 0x4e00004, CODE_FOR_iorbi3 },
  { 0x4e00008, CODE_FOR_iordi3 },
  { 0x4e00032, CODE_FOR_iorv8qi3 },
  { 0x4e00033, CODE_FOR_iorv4hi3 },
  { 0x4e00034, CODE_FOR_iorv2si3 },
  { 0x4f00008, CODE_FOR_xordi3 },
  { 0x4f00032, CODE_FOR_xorv8qi3 },
  { 0x4f00033, CODE_FOR_xorv4hi3 },
  { 0x4f00034, CODE_FOR_xorv2si3 },
  { 0x5000007, CODE_FOR_ashlsi3 },
  { 0x5000008, CODE_FOR_ashldi3 },
  { 0x5000009, CODE_FOR_ashlti3 },
  { 0x5000033, CODE_FOR_ashlv4hi3 },
  { 0x5000034, CODE_FOR_ashlv2si3 },
  { 0x5300007, CODE_FOR_ashrsi3 },
  { 0x5300008, CODE_FOR_ashrdi3 },
  { 0x5300009, CODE_FOR_ashrti3 },
  { 0x5300033, CODE_FOR_ashrv4hi3 },
  { 0x5300034, CODE_FOR_ashrv2si3 },
  { 0x5400007, CODE_FOR_lshrsi3 },
  { 0x5400008, CODE_FOR_lshrdi3 },
  { 0x5400009, CODE_FOR_lshrti3 },
  { 0x5400033, CODE_FOR_lshrv4hi3 },
  { 0x5400034, CODE_FOR_lshrv2si3 },
  { 0x5500007, CODE_FOR_rotlsi3 },
  { 0x5500008, CODE_FOR_rotldi3 },
  { 0x5500009, CODE_FOR_rotlti3 },
  { 0x5600007, CODE_FOR_rotrsi3 },
  { 0x5600008, CODE_FOR_rotrdi3 },
  { 0x5c00007, CODE_FOR_sminsi3 },
  { 0x5c00008, CODE_FOR_smindi3 },
  { 0x5c0001d, CODE_FOR_sminsf3 },
  { 0x5c0001e, CODE_FOR_smindf3 },
  { 0x5c0001f, CODE_FOR_sminxf3 },
  { 0x5c00032, CODE_FOR_sminv8qi3 },
  { 0x5c00033, CODE_FOR_sminv4hi3 },
  { 0x5c00034, CODE_FOR_sminv2si3 },
  { 0x5c00038, CODE_FOR_sminv2sf3 },
  { 0x5d00007, CODE_FOR_smaxsi3 },
  { 0x5d00008, CODE_FOR_smaxdi3 },
  { 0x5d0001d, CODE_FOR_smaxsf3 },
  { 0x5d0001e, CODE_FOR_smaxdf3 },
  { 0x5d0001f, CODE_FOR_smaxxf3 },
  { 0x5d00032, CODE_FOR_smaxv8qi3 },
  { 0x5d00033, CODE_FOR_smaxv4hi3 },
  { 0x5d00034, CODE_FOR_smaxv2si3 },
  { 0x5d00038, CODE_FOR_smaxv2sf3 },
  { 0x5e00007, CODE_FOR_uminsi3 },
  { 0x5e00008, CODE_FOR_umindi3 },
  { 0x5e00032, CODE_FOR_uminv8qi3 },
  { 0x5e00033, CODE_FOR_uminv4hi3 },
  { 0x5e00034, CODE_FOR_uminv2si3 },
  { 0x5f00007, CODE_FOR_umaxsi3 },
  { 0x5f00008, CODE_FOR_umaxdi3 },
  { 0x5f00032, CODE_FOR_umaxv8qi3 },
  { 0x5f00033, CODE_FOR_umaxv4hi3 },
  { 0x5f00034, CODE_FOR_umaxv2si3 },
  { 0x6000007, CODE_FOR_negsi2 },
  { 0x6000008, CODE_FOR_negdi2 },
  { 0x6000009, CODE_FOR_negti2 },
  { 0x600001d, CODE_FOR_negsf2 },
  { 0x600001e, CODE_FOR_negdf2 },
  { 0x600001f, CODE_FOR_negxf2 },
  { 0x6000032, CODE_FOR_negv8qi2 },
  { 0x6000033, CODE_FOR_negv4hi2 },
  { 0x6000034, CODE_FOR_negv2si2 },
  { 0x6000038, CODE_FOR_negv2sf2 },
  { 0x6400007, CODE_FOR_abssi2 },
  { 0x6400008, CODE_FOR_absdi2 },
  { 0x640001d, CODE_FOR_abssf2 },
  { 0x640001e, CODE_FOR_absdf2 },
  { 0x640001f, CODE_FOR_absxf2 },
  { 0x6400038, CODE_FOR_absv2sf2 },
  { 0x6600004, CODE_FOR_one_cmplbi2 },
  { 0x6600007, CODE_FOR_one_cmplsi2 },
  { 0x6600008, CODE_FOR_one_cmpldi2 },
  { 0x6600032, CODE_FOR_one_cmplv8qi2 },
  { 0x6600033, CODE_FOR_one_cmplv4hi2 },
  { 0x6600034, CODE_FOR_one_cmplv2si2 },
  { 0x6700008, CODE_FOR_bswapdi2 },
  { 0x6800008, CODE_FOR_ffsdi2 },
  { 0x6900008, CODE_FOR_clzdi2 },
  { 0x6a00008, CODE_FOR_ctzdi2 },
  { 0x6c00008, CODE_FOR_popcountdi2 },
  { 0x780001d, CODE_FOR_sqrtsf2 },
  { 0x780001e, CODE_FOR_sqrtdf2 },
  { 0x780001f, CODE_FOR_sqrtxf2 },
  { 0x8700003, CODE_FOR_movcci },
  { 0x8700004, CODE_FOR_movbi },
  { 0x8700005, CODE_FOR_movqi },
  { 0x8700006, CODE_FOR_movhi },
  { 0x8700007, CODE_FOR_movsi },
  { 0x8700008, CODE_FOR_movdi },
  { 0x8700009, CODE_FOR_movti },
  { 0x870001d, CODE_FOR_movsf },
  { 0x870001e, CODE_FOR_movdf },
  { 0x870001f, CODE_FOR_movxf },
  { 0x8700020, CODE_FOR_movrf },
  { 0x8700021, CODE_FOR_movtf },
  { 0x8700032, CODE_FOR_movv8qi },
  { 0x8700033, CODE_FOR_movv4hi },
  { 0x8700034, CODE_FOR_movv2si },
  { 0x8700038, CODE_FOR_movv2sf },
  { 0x9400004, CODE_FOR_cbranchbi4 },
  { 0x9400007, CODE_FOR_cbranchsi4 },
  { 0x9400008, CODE_FOR_cbranchdi4 },
  { 0x940001d, CODE_FOR_cbranchsf4 },
  { 0x940001e, CODE_FOR_cbranchdf4 },
  { 0x940001f, CODE_FOR_cbranchxf4 },
  { 0xd100004, CODE_FOR_cstorebi4 },
  { 0xd100007, CODE_FOR_cstoresi4 },
  { 0xd100008, CODE_FOR_cstoredi4 },
  { 0xd10001d, CODE_FOR_cstoresf4 },
  { 0xd10001e, CODE_FOR_cstoredf4 },
  { 0xd10001f, CODE_FOR_cstorexf4 },
  { 0xd200004, CODE_FOR_ctrapbi4 },
  { 0xd200007, CODE_FOR_ctrapsi4 },
  { 0xd200008, CODE_FOR_ctrapdi4 },
  { 0xd20001d, CODE_FOR_ctrapsf4 },
  { 0xd20001e, CODE_FOR_ctrapdf4 },
  { 0xd20001f, CODE_FOR_ctrapxf4 },
  { 0xde00008, CODE_FOR_smuldi3_highpart },
  { 0xde00033, CODE_FOR_smulv4hi3_highpart },
  { 0xdf00008, CODE_FOR_umuldi3_highpart },
  { 0xdf00033, CODE_FOR_umulv4hi3_highpart },
  { 0xe80001d, CODE_FOR_fmasf4 },
  { 0xe80001e, CODE_FOR_fmadf4 },
  { 0xe80001f, CODE_FOR_fmaxf4 },
  { 0xe800038, CODE_FOR_fmav2sf4 },
  { 0xe90001d, CODE_FOR_fmssf4 },
  { 0xe90001e, CODE_FOR_fmsdf4 },
  { 0xe90001f, CODE_FOR_fmsxf4 },
  { 0xe900038, CODE_FOR_fmsv2sf4 },
  { 0xea0001d, CODE_FOR_fnmasf4 },
  { 0xea0001e, CODE_FOR_fnmadf4 },
  { 0xea0001f, CODE_FOR_fnmaxf4 },
  { 0xea00038, CODE_FOR_fnmav2sf4 },
  { 0xfa0001d, CODE_FOR_copysignsf3 },
  { 0xfa0001e, CODE_FOR_copysigndf3 },
  { 0xfa0001f, CODE_FOR_copysignxf3 },
  { 0x13c00032, CODE_FOR_widen_ssumv8qi3 },
  { 0x13c00033, CODE_FOR_widen_ssumv4hi3 },
  { 0x13f00032, CODE_FOR_widen_usumv8qi3 },
  { 0x13f00033, CODE_FOR_widen_usumv4hi3 },
  { 0x14800033, CODE_FOR_vec_pack_ssat_v4hi },
  { 0x14800034, CODE_FOR_vec_pack_ssat_v2si },
  { 0x14900033, CODE_FOR_vec_pack_trunc_v4hi },
  { 0x14900034, CODE_FOR_vec_pack_trunc_v2si },
  { 0x14c00033, CODE_FOR_vec_pack_usat_v4hi },
  { 0x15100038, CODE_FOR_vec_setv2sf },
  { 0x15200032, CODE_FOR_vec_shl_v8qi },
  { 0x15200033, CODE_FOR_vec_shl_v4hi },
  { 0x15200034, CODE_FOR_vec_shl_v2si },
  { 0x15300032, CODE_FOR_vec_shr_v8qi },
  { 0x15300033, CODE_FOR_vec_shr_v4hi },
  { 0x15300034, CODE_FOR_vec_shr_v2si },
  { 0x15a00032, CODE_FOR_vec_unpacks_hi_v8qi },
  { 0x15a00033, CODE_FOR_vec_unpacks_hi_v4hi },
  { 0x15b00032, CODE_FOR_vec_unpacks_lo_v8qi },
  { 0x15b00033, CODE_FOR_vec_unpacks_lo_v4hi },
  { 0x16000032, CODE_FOR_vec_unpacku_hi_v8qi },
  { 0x16000033, CODE_FOR_vec_unpacku_hi_v4hi },
  { 0x16100032, CODE_FOR_vec_unpacku_lo_v8qi },
  { 0x16100033, CODE_FOR_vec_unpacku_lo_v4hi },
  { 0x16200033, CODE_FOR_vec_widen_smult_even_v4hi },
  { 0x16300032, CODE_FOR_vec_widen_smult_hi_v8qi },
  { 0x16300033, CODE_FOR_vec_widen_smult_hi_v4hi },
  { 0x16400032, CODE_FOR_vec_widen_smult_lo_v8qi },
  { 0x16400033, CODE_FOR_vec_widen_smult_lo_v4hi },
  { 0x16500033, CODE_FOR_vec_widen_smult_odd_v4hi },
  { 0x17800032, CODE_FOR_vec_widen_umult_hi_v8qi },
  { 0x17800033, CODE_FOR_vec_widen_umult_hi_v4hi },
  { 0x17900032, CODE_FOR_vec_widen_umult_lo_v8qi },
  { 0x17900033, CODE_FOR_vec_widen_umult_lo_v4hi },
  { 0x19600005, CODE_FOR_atomic_add_fetchqi },
  { 0x19600006, CODE_FOR_atomic_add_fetchhi },
  { 0x19600007, CODE_FOR_atomic_add_fetchsi },
  { 0x19600008, CODE_FOR_atomic_add_fetchdi },
  { 0x19700005, CODE_FOR_atomic_addqi },
  { 0x19700006, CODE_FOR_atomic_addhi },
  { 0x19700007, CODE_FOR_atomic_addsi },
  { 0x19700008, CODE_FOR_atomic_adddi },
  { 0x19800005, CODE_FOR_atomic_and_fetchqi },
  { 0x19800006, CODE_FOR_atomic_and_fetchhi },
  { 0x19800007, CODE_FOR_atomic_and_fetchsi },
  { 0x19800008, CODE_FOR_atomic_and_fetchdi },
  { 0x19900005, CODE_FOR_atomic_andqi },
  { 0x19900006, CODE_FOR_atomic_andhi },
  { 0x19900007, CODE_FOR_atomic_andsi },
  { 0x19900008, CODE_FOR_atomic_anddi },
  { 0x19d00005, CODE_FOR_atomic_compare_and_swapqi },
  { 0x19d00006, CODE_FOR_atomic_compare_and_swaphi },
  { 0x19d00007, CODE_FOR_atomic_compare_and_swapsi },
  { 0x19d00008, CODE_FOR_atomic_compare_and_swapdi },
  { 0x19e00005, CODE_FOR_atomic_exchangeqi },
  { 0x19e00006, CODE_FOR_atomic_exchangehi },
  { 0x19e00007, CODE_FOR_atomic_exchangesi },
  { 0x19e00008, CODE_FOR_atomic_exchangedi },
  { 0x19f00005, CODE_FOR_atomic_fetch_addqi },
  { 0x19f00006, CODE_FOR_atomic_fetch_addhi },
  { 0x19f00007, CODE_FOR_atomic_fetch_addsi },
  { 0x19f00008, CODE_FOR_atomic_fetch_adddi },
  { 0x1a000005, CODE_FOR_atomic_fetch_andqi },
  { 0x1a000006, CODE_FOR_atomic_fetch_andhi },
  { 0x1a000007, CODE_FOR_atomic_fetch_andsi },
  { 0x1a000008, CODE_FOR_atomic_fetch_anddi },
  { 0x1a100005, CODE_FOR_atomic_fetch_nandqi },
  { 0x1a100006, CODE_FOR_atomic_fetch_nandhi },
  { 0x1a100007, CODE_FOR_atomic_fetch_nandsi },
  { 0x1a100008, CODE_FOR_atomic_fetch_nanddi },
  { 0x1a200005, CODE_FOR_atomic_fetch_orqi },
  { 0x1a200006, CODE_FOR_atomic_fetch_orhi },
  { 0x1a200007, CODE_FOR_atomic_fetch_orsi },
  { 0x1a200008, CODE_FOR_atomic_fetch_ordi },
  { 0x1a300005, CODE_FOR_atomic_fetch_subqi },
  { 0x1a300006, CODE_FOR_atomic_fetch_subhi },
  { 0x1a300007, CODE_FOR_atomic_fetch_subsi },
  { 0x1a300008, CODE_FOR_atomic_fetch_subdi },
  { 0x1a400005, CODE_FOR_atomic_fetch_xorqi },
  { 0x1a400006, CODE_FOR_atomic_fetch_xorhi },
  { 0x1a400007, CODE_FOR_atomic_fetch_xorsi },
  { 0x1a400008, CODE_FOR_atomic_fetch_xordi },
  { 0x1a500005, CODE_FOR_atomic_loadqi },
  { 0x1a500006, CODE_FOR_atomic_loadhi },
  { 0x1a500007, CODE_FOR_atomic_loadsi },
  { 0x1a500008, CODE_FOR_atomic_loaddi },
  { 0x1a600005, CODE_FOR_atomic_nand_fetchqi },
  { 0x1a600006, CODE_FOR_atomic_nand_fetchhi },
  { 0x1a600007, CODE_FOR_atomic_nand_fetchsi },
  { 0x1a600008, CODE_FOR_atomic_nand_fetchdi },
  { 0x1a700005, CODE_FOR_atomic_nandqi },
  { 0x1a700006, CODE_FOR_atomic_nandhi },
  { 0x1a700007, CODE_FOR_atomic_nandsi },
  { 0x1a700008, CODE_FOR_atomic_nanddi },
  { 0x1a800005, CODE_FOR_atomic_or_fetchqi },
  { 0x1a800006, CODE_FOR_atomic_or_fetchhi },
  { 0x1a800007, CODE_FOR_atomic_or_fetchsi },
  { 0x1a800008, CODE_FOR_atomic_or_fetchdi },
  { 0x1a900005, CODE_FOR_atomic_orqi },
  { 0x1a900006, CODE_FOR_atomic_orhi },
  { 0x1a900007, CODE_FOR_atomic_orsi },
  { 0x1a900008, CODE_FOR_atomic_ordi },
  { 0x1aa00005, CODE_FOR_atomic_storeqi },
  { 0x1aa00006, CODE_FOR_atomic_storehi },
  { 0x1aa00007, CODE_FOR_atomic_storesi },
  { 0x1aa00008, CODE_FOR_atomic_storedi },
  { 0x1ab00005, CODE_FOR_atomic_sub_fetchqi },
  { 0x1ab00006, CODE_FOR_atomic_sub_fetchhi },
  { 0x1ab00007, CODE_FOR_atomic_sub_fetchsi },
  { 0x1ab00008, CODE_FOR_atomic_sub_fetchdi },
  { 0x1ac00005, CODE_FOR_atomic_subqi },
  { 0x1ac00006, CODE_FOR_atomic_subhi },
  { 0x1ac00007, CODE_FOR_atomic_subsi },
  { 0x1ac00008, CODE_FOR_atomic_subdi },
  { 0x1ad00005, CODE_FOR_atomic_xor_fetchqi },
  { 0x1ad00006, CODE_FOR_atomic_xor_fetchhi },
  { 0x1ad00007, CODE_FOR_atomic_xor_fetchsi },
  { 0x1ad00008, CODE_FOR_atomic_xor_fetchdi },
  { 0x1ae00005, CODE_FOR_atomic_xorqi },
  { 0x1ae00006, CODE_FOR_atomic_xorhi },
  { 0x1ae00007, CODE_FOR_atomic_xorsi },
  { 0x1ae00008, CODE_FOR_atomic_xordi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqidi2;
  ena[1] = HAVE_extendhidi2;
  ena[2] = HAVE_extendsidi2;
  ena[3] = HAVE_extendsfdf2;
  ena[4] = HAVE_extendsfxf2;
  ena[5] = HAVE_extendsfrf2;
  ena[6] = HAVE_extenddfxf2;
  ena[7] = HAVE_extenddfrf2;
  ena[8] = HAVE_extendxfrf2;
  ena[9] = HAVE_truncdfsf2;
  ena[10] = HAVE_truncxfsf2;
  ena[11] = HAVE_truncxfdf2;
  ena[12] = HAVE_truncrfsf2;
  ena[13] = HAVE_truncrfdf2;
  ena[14] = HAVE_truncrfxf2;
  ena[15] = HAVE_zero_extendqidi2;
  ena[16] = HAVE_zero_extendhidi2;
  ena[17] = HAVE_zero_extendsidi2;
  ena[18] = HAVE_floatdixf2;
  ena[19] = HAVE_floatdirf2;
  ena[20] = HAVE_floatunsdisf2;
  ena[21] = HAVE_floatunsdidf2;
  ena[22] = HAVE_floatunsdixf2;
  ena[23] = HAVE_floatunsdirf2;
  ena[24] = HAVE_fix_truncsfdi2;
  ena[25] = HAVE_fix_truncdfdi2;
  ena[26] = HAVE_fix_truncxfdi2;
  ena[27] = HAVE_fix_truncrfdi2;
  ena[28] = HAVE_fixuns_truncsfdi2;
  ena[29] = HAVE_fixuns_truncdfdi2;
  ena[30] = HAVE_fixuns_truncxfdi2;
  ena[31] = HAVE_fixuns_truncrfdi2;
  ena[32] = HAVE_mulditi3;
  ena[33] = HAVE_umulditi3;
  ena[34] = HAVE_vcondv8qiv8qi;
  ena[35] = HAVE_vcondv4hiv4hi;
  ena[36] = HAVE_vcondv2siv2si;
  ena[37] = HAVE_vcondv2sfv2sf;
  ena[38] = HAVE_vconduv8qiv8qi;
  ena[39] = HAVE_vconduv4hiv4hi;
  ena[40] = HAVE_vconduv2siv2si;
  ena[41] = HAVE_vec_extractv2sfsf;
  ena[42] = HAVE_vec_initv2sisi;
  ena[43] = HAVE_vec_initv2sfsf;
  ena[44] = HAVE_addsi3;
  ena[45] = HAVE_adddi3;
  ena[46] = HAVE_addti3;
  ena[47] = HAVE_addsf3;
  ena[48] = HAVE_adddf3;
  ena[49] = HAVE_addxf3;
  ena[50] = HAVE_addv8qi3;
  ena[51] = HAVE_addv4hi3;
  ena[52] = HAVE_addv2si3;
  ena[53] = HAVE_addv2sf3;
  ena[54] = HAVE_subsi3;
  ena[55] = HAVE_subdi3;
  ena[56] = HAVE_subti3;
  ena[57] = HAVE_subsf3;
  ena[58] = HAVE_subdf3;
  ena[59] = HAVE_subxf3;
  ena[60] = HAVE_subv8qi3;
  ena[61] = HAVE_subv4hi3;
  ena[62] = HAVE_subv2si3;
  ena[63] = HAVE_subv2sf3;
  ena[64] = HAVE_mulhi3;
  ena[65] = HAVE_mulsi3;
  ena[66] = HAVE_muldi3;
  ena[67] = HAVE_mulsf3;
  ena[68] = HAVE_muldf3;
  ena[69] = HAVE_mulxf3;
  ena[70] = HAVE_mulv8qi3;
  ena[71] = HAVE_mulv4hi3;
  ena[72] = HAVE_mulv2si3;
  ena[73] = HAVE_mulv2sf3;
  ena[74] = HAVE_divsi3;
  ena[75] = HAVE_divdi3;
  ena[76] = HAVE_divsf3;
  ena[77] = HAVE_divdf3;
  ena[78] = HAVE_divxf3;
  ena[79] = HAVE_udivsi3;
  ena[80] = HAVE_udivdi3;
  ena[81] = HAVE_modsi3;
  ena[82] = HAVE_moddi3;
  ena[83] = HAVE_umodsi3;
  ena[84] = HAVE_umoddi3;
  ena[85] = HAVE_andbi3;
  ena[86] = HAVE_anddi3;
  ena[87] = HAVE_andv8qi3;
  ena[88] = HAVE_andv4hi3;
  ena[89] = HAVE_andv2si3;
  ena[90] = HAVE_iorbi3;
  ena[91] = HAVE_iordi3;
  ena[92] = HAVE_iorv8qi3;
  ena[93] = HAVE_iorv4hi3;
  ena[94] = HAVE_iorv2si3;
  ena[95] = HAVE_xordi3;
  ena[96] = HAVE_xorv8qi3;
  ena[97] = HAVE_xorv4hi3;
  ena[98] = HAVE_xorv2si3;
  ena[99] = HAVE_ashlsi3;
  ena[100] = HAVE_ashldi3;
  ena[101] = HAVE_ashlti3;
  ena[102] = HAVE_ashlv4hi3;
  ena[103] = HAVE_ashlv2si3;
  ena[104] = HAVE_ashrsi3;
  ena[105] = HAVE_ashrdi3;
  ena[106] = HAVE_ashrti3;
  ena[107] = HAVE_ashrv4hi3;
  ena[108] = HAVE_ashrv2si3;
  ena[109] = HAVE_lshrsi3;
  ena[110] = HAVE_lshrdi3;
  ena[111] = HAVE_lshrti3;
  ena[112] = HAVE_lshrv4hi3;
  ena[113] = HAVE_lshrv2si3;
  ena[114] = HAVE_rotlsi3;
  ena[115] = HAVE_rotldi3;
  ena[116] = HAVE_rotlti3;
  ena[117] = HAVE_rotrsi3;
  ena[118] = HAVE_rotrdi3;
  ena[119] = HAVE_sminsi3;
  ena[120] = HAVE_smindi3;
  ena[121] = HAVE_sminsf3;
  ena[122] = HAVE_smindf3;
  ena[123] = HAVE_sminxf3;
  ena[124] = HAVE_sminv8qi3;
  ena[125] = HAVE_sminv4hi3;
  ena[126] = HAVE_sminv2si3;
  ena[127] = HAVE_sminv2sf3;
  ena[128] = HAVE_smaxsi3;
  ena[129] = HAVE_smaxdi3;
  ena[130] = HAVE_smaxsf3;
  ena[131] = HAVE_smaxdf3;
  ena[132] = HAVE_smaxxf3;
  ena[133] = HAVE_smaxv8qi3;
  ena[134] = HAVE_smaxv4hi3;
  ena[135] = HAVE_smaxv2si3;
  ena[136] = HAVE_smaxv2sf3;
  ena[137] = HAVE_uminsi3;
  ena[138] = HAVE_umindi3;
  ena[139] = HAVE_uminv8qi3;
  ena[140] = HAVE_uminv4hi3;
  ena[141] = HAVE_uminv2si3;
  ena[142] = HAVE_umaxsi3;
  ena[143] = HAVE_umaxdi3;
  ena[144] = HAVE_umaxv8qi3;
  ena[145] = HAVE_umaxv4hi3;
  ena[146] = HAVE_umaxv2si3;
  ena[147] = HAVE_negsi2;
  ena[148] = HAVE_negdi2;
  ena[149] = HAVE_negti2;
  ena[150] = HAVE_negsf2;
  ena[151] = HAVE_negdf2;
  ena[152] = HAVE_negxf2;
  ena[153] = HAVE_negv8qi2;
  ena[154] = HAVE_negv4hi2;
  ena[155] = HAVE_negv2si2;
  ena[156] = HAVE_negv2sf2;
  ena[157] = HAVE_abssi2;
  ena[158] = HAVE_absdi2;
  ena[159] = HAVE_abssf2;
  ena[160] = HAVE_absdf2;
  ena[161] = HAVE_absxf2;
  ena[162] = HAVE_absv2sf2;
  ena[163] = HAVE_one_cmplbi2;
  ena[164] = HAVE_one_cmplsi2;
  ena[165] = HAVE_one_cmpldi2;
  ena[166] = HAVE_one_cmplv8qi2;
  ena[167] = HAVE_one_cmplv4hi2;
  ena[168] = HAVE_one_cmplv2si2;
  ena[169] = HAVE_bswapdi2;
  ena[170] = HAVE_ffsdi2;
  ena[171] = HAVE_clzdi2;
  ena[172] = HAVE_ctzdi2;
  ena[173] = HAVE_popcountdi2;
  ena[174] = HAVE_sqrtsf2;
  ena[175] = HAVE_sqrtdf2;
  ena[176] = HAVE_sqrtxf2;
  ena[177] = HAVE_movcci;
  ena[178] = HAVE_movbi;
  ena[179] = HAVE_movqi;
  ena[180] = HAVE_movhi;
  ena[181] = HAVE_movsi;
  ena[182] = HAVE_movdi;
  ena[183] = HAVE_movti;
  ena[184] = HAVE_movsf;
  ena[185] = HAVE_movdf;
  ena[186] = HAVE_movxf;
  ena[187] = HAVE_movrf;
  ena[188] = HAVE_movtf;
  ena[189] = HAVE_movv8qi;
  ena[190] = HAVE_movv4hi;
  ena[191] = HAVE_movv2si;
  ena[192] = HAVE_movv2sf;
  ena[193] = HAVE_cbranchbi4;
  ena[194] = HAVE_cbranchsi4;
  ena[195] = HAVE_cbranchdi4;
  ena[196] = HAVE_cbranchsf4;
  ena[197] = HAVE_cbranchdf4;
  ena[198] = HAVE_cbranchxf4;
  ena[199] = HAVE_cstorebi4;
  ena[200] = HAVE_cstoresi4;
  ena[201] = HAVE_cstoredi4;
  ena[202] = HAVE_cstoresf4;
  ena[203] = HAVE_cstoredf4;
  ena[204] = HAVE_cstorexf4;
  ena[205] = HAVE_ctrapbi4;
  ena[206] = HAVE_ctrapsi4;
  ena[207] = HAVE_ctrapdi4;
  ena[208] = HAVE_ctrapsf4;
  ena[209] = HAVE_ctrapdf4;
  ena[210] = HAVE_ctrapxf4;
  ena[211] = HAVE_smuldi3_highpart;
  ena[212] = HAVE_smulv4hi3_highpart;
  ena[213] = HAVE_umuldi3_highpart;
  ena[214] = HAVE_umulv4hi3_highpart;
  ena[215] = HAVE_fmasf4;
  ena[216] = HAVE_fmadf4;
  ena[217] = HAVE_fmaxf4;
  ena[218] = HAVE_fmav2sf4;
  ena[219] = HAVE_fmssf4;
  ena[220] = HAVE_fmsdf4;
  ena[221] = HAVE_fmsxf4;
  ena[222] = HAVE_fmsv2sf4;
  ena[223] = HAVE_fnmasf4;
  ena[224] = HAVE_fnmadf4;
  ena[225] = HAVE_fnmaxf4;
  ena[226] = HAVE_fnmav2sf4;
  ena[227] = HAVE_copysignsf3;
  ena[228] = HAVE_copysigndf3;
  ena[229] = HAVE_copysignxf3;
  ena[230] = HAVE_widen_ssumv8qi3;
  ena[231] = HAVE_widen_ssumv4hi3;
  ena[232] = HAVE_widen_usumv8qi3;
  ena[233] = HAVE_widen_usumv4hi3;
  ena[234] = HAVE_vec_pack_ssat_v4hi;
  ena[235] = HAVE_vec_pack_ssat_v2si;
  ena[236] = HAVE_vec_pack_trunc_v4hi;
  ena[237] = HAVE_vec_pack_trunc_v2si;
  ena[238] = HAVE_vec_pack_usat_v4hi;
  ena[239] = HAVE_vec_setv2sf;
  ena[240] = HAVE_vec_shl_v8qi;
  ena[241] = HAVE_vec_shl_v4hi;
  ena[242] = HAVE_vec_shl_v2si;
  ena[243] = HAVE_vec_shr_v8qi;
  ena[244] = HAVE_vec_shr_v4hi;
  ena[245] = HAVE_vec_shr_v2si;
  ena[246] = HAVE_vec_unpacks_hi_v8qi;
  ena[247] = HAVE_vec_unpacks_hi_v4hi;
  ena[248] = HAVE_vec_unpacks_lo_v8qi;
  ena[249] = HAVE_vec_unpacks_lo_v4hi;
  ena[250] = HAVE_vec_unpacku_hi_v8qi;
  ena[251] = HAVE_vec_unpacku_hi_v4hi;
  ena[252] = HAVE_vec_unpacku_lo_v8qi;
  ena[253] = HAVE_vec_unpacku_lo_v4hi;
  ena[254] = HAVE_vec_widen_smult_even_v4hi;
  ena[255] = HAVE_vec_widen_smult_hi_v8qi;
  ena[256] = HAVE_vec_widen_smult_hi_v4hi;
  ena[257] = HAVE_vec_widen_smult_lo_v8qi;
  ena[258] = HAVE_vec_widen_smult_lo_v4hi;
  ena[259] = HAVE_vec_widen_smult_odd_v4hi;
  ena[260] = HAVE_vec_widen_umult_hi_v8qi;
  ena[261] = HAVE_vec_widen_umult_hi_v4hi;
  ena[262] = HAVE_vec_widen_umult_lo_v8qi;
  ena[263] = HAVE_vec_widen_umult_lo_v4hi;
  ena[264] = HAVE_atomic_add_fetchqi;
  ena[265] = HAVE_atomic_add_fetchhi;
  ena[266] = HAVE_atomic_add_fetchsi;
  ena[267] = HAVE_atomic_add_fetchdi;
  ena[268] = HAVE_atomic_addqi;
  ena[269] = HAVE_atomic_addhi;
  ena[270] = HAVE_atomic_addsi;
  ena[271] = HAVE_atomic_adddi;
  ena[272] = HAVE_atomic_and_fetchqi;
  ena[273] = HAVE_atomic_and_fetchhi;
  ena[274] = HAVE_atomic_and_fetchsi;
  ena[275] = HAVE_atomic_and_fetchdi;
  ena[276] = HAVE_atomic_andqi;
  ena[277] = HAVE_atomic_andhi;
  ena[278] = HAVE_atomic_andsi;
  ena[279] = HAVE_atomic_anddi;
  ena[280] = HAVE_atomic_compare_and_swapqi;
  ena[281] = HAVE_atomic_compare_and_swaphi;
  ena[282] = HAVE_atomic_compare_and_swapsi;
  ena[283] = HAVE_atomic_compare_and_swapdi;
  ena[284] = HAVE_atomic_exchangeqi;
  ena[285] = HAVE_atomic_exchangehi;
  ena[286] = HAVE_atomic_exchangesi;
  ena[287] = HAVE_atomic_exchangedi;
  ena[288] = HAVE_atomic_fetch_addqi;
  ena[289] = HAVE_atomic_fetch_addhi;
  ena[290] = HAVE_atomic_fetch_addsi;
  ena[291] = HAVE_atomic_fetch_adddi;
  ena[292] = HAVE_atomic_fetch_andqi;
  ena[293] = HAVE_atomic_fetch_andhi;
  ena[294] = HAVE_atomic_fetch_andsi;
  ena[295] = HAVE_atomic_fetch_anddi;
  ena[296] = HAVE_atomic_fetch_nandqi;
  ena[297] = HAVE_atomic_fetch_nandhi;
  ena[298] = HAVE_atomic_fetch_nandsi;
  ena[299] = HAVE_atomic_fetch_nanddi;
  ena[300] = HAVE_atomic_fetch_orqi;
  ena[301] = HAVE_atomic_fetch_orhi;
  ena[302] = HAVE_atomic_fetch_orsi;
  ena[303] = HAVE_atomic_fetch_ordi;
  ena[304] = HAVE_atomic_fetch_subqi;
  ena[305] = HAVE_atomic_fetch_subhi;
  ena[306] = HAVE_atomic_fetch_subsi;
  ena[307] = HAVE_atomic_fetch_subdi;
  ena[308] = HAVE_atomic_fetch_xorqi;
  ena[309] = HAVE_atomic_fetch_xorhi;
  ena[310] = HAVE_atomic_fetch_xorsi;
  ena[311] = HAVE_atomic_fetch_xordi;
  ena[312] = HAVE_atomic_loadqi;
  ena[313] = HAVE_atomic_loadhi;
  ena[314] = HAVE_atomic_loadsi;
  ena[315] = HAVE_atomic_loaddi;
  ena[316] = HAVE_atomic_nand_fetchqi;
  ena[317] = HAVE_atomic_nand_fetchhi;
  ena[318] = HAVE_atomic_nand_fetchsi;
  ena[319] = HAVE_atomic_nand_fetchdi;
  ena[320] = HAVE_atomic_nandqi;
  ena[321] = HAVE_atomic_nandhi;
  ena[322] = HAVE_atomic_nandsi;
  ena[323] = HAVE_atomic_nanddi;
  ena[324] = HAVE_atomic_or_fetchqi;
  ena[325] = HAVE_atomic_or_fetchhi;
  ena[326] = HAVE_atomic_or_fetchsi;
  ena[327] = HAVE_atomic_or_fetchdi;
  ena[328] = HAVE_atomic_orqi;
  ena[329] = HAVE_atomic_orhi;
  ena[330] = HAVE_atomic_orsi;
  ena[331] = HAVE_atomic_ordi;
  ena[332] = HAVE_atomic_storeqi;
  ena[333] = HAVE_atomic_storehi;
  ena[334] = HAVE_atomic_storesi;
  ena[335] = HAVE_atomic_storedi;
  ena[336] = HAVE_atomic_sub_fetchqi;
  ena[337] = HAVE_atomic_sub_fetchhi;
  ena[338] = HAVE_atomic_sub_fetchsi;
  ena[339] = HAVE_atomic_sub_fetchdi;
  ena[340] = HAVE_atomic_subqi;
  ena[341] = HAVE_atomic_subhi;
  ena[342] = HAVE_atomic_subsi;
  ena[343] = HAVE_atomic_subdi;
  ena[344] = HAVE_atomic_xor_fetchqi;
  ena[345] = HAVE_atomic_xor_fetchhi;
  ena[346] = HAVE_atomic_xor_fetchsi;
  ena[347] = HAVE_atomic_xor_fetchdi;
  ena[348] = HAVE_atomic_xorqi;
  ena[349] = HAVE_atomic_xorhi;
  ena[350] = HAVE_atomic_xorsi;
  ena[351] = HAVE_atomic_xordi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

