/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-14.2.1-20240912/gcc/config/ia64/ia64.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 54 "../../gcc-14.2.1-20240912/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 60 "../../gcc-14.2.1-20240912/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 69 "../../gcc-14.2.1-20240912/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 71 "../../gcc-14.2.1-20240912/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 78 "../../gcc-14.2.1-20240912/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 79 "../../gcc-14.2.1-20240912/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 85 "../../gcc-14.2.1-20240912/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 86 "../../gcc-14.2.1-20240912/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 90 "../../gcc-14.2.1-20240912/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 94 "../../gcc-14.2.1-20240912/gcc/common.md"
(CONSTANT_P (op))) && (
#line 95 "../../gcc-14.2.1-20240912/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 99 "../../gcc-14.2.1-20240912/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 100 "../../gcc-14.2.1-20240912/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 101 "../../gcc-14.2.1-20240912/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 105 "../../gcc-14.2.1-20240912/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 106 "../../gcc-14.2.1-20240912/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 110 "../../gcc-14.2.1-20240912/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 111 "../../gcc-14.2.1-20240912/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 117 "../../gcc-14.2.1-20240912/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 118 "../../gcc-14.2.1-20240912/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 123 "../../gcc-14.2.1-20240912/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 48 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival + 0x2000 < 0x4000));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 53 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival + 0x200000 < 0x400000));
}
static inline bool
satisfies_constraint_j (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 58 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival >= 0xffffe000
		    && (unsigned HOST_WIDE_INT)ival <= 0xffffffff));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 64 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival + 0x80 < 0x100));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 69 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival + 0x7F < 0x100));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 74 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival < 0x40));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 79 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
((unsigned HOST_WIDE_INT)ival + 0x100 < 0x200));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 84 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 89 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(ival == 0 || ival == -1));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 96 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(op == CONST0_RTX (mode) || op == CONST1_RTX (mode)));
}
static inline bool
satisfies_constraint_Z (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_DOUBLE) && ((
#line 101 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(op == CONST1_RTX (mode))) || ((
#line 102 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(op == CONST0_RTX (mode))) && (
#line 103 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(!flag_signed_zeros))));
}
static inline bool
satisfies_constraint_H (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 108 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(op == CONST0_RTX (mode)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (memory_operand (op, mode)) && (
#line 118 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(!MEM_VOLATILE_P (op)));
}
static inline bool
satisfies_constraint_R (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 123 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(ival >= 1 && ival <= 4));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return small_addr_symbolic_operand (op, mode);
}
static inline bool
satisfies_constraint_U (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_VECTOR) && (
#line 132 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(op == CONST0_RTX (mode)));
}
static inline bool
satisfies_constraint_W (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_VECTOR) && ((
#line 138 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(GET_MODE_CLASS (mode) == MODE_VECTOR_INT)) && (
#line 140 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(satisfies_constraint_J (simplify_subreg (DImode, op, mode, 0)))));
}
static inline bool
satisfies_constraint_Y (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_VECTOR) && ((
#line 145 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(mode == V2SFmode)) && ((
#line 146 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(satisfies_constraint_G (XVECEXP (op, 0, 0)))) && (
#line 147 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(satisfies_constraint_G (XVECEXP (op, 0, 1))))));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 154 "../../gcc-14.2.1-20240912/gcc/config/ia64/constraints.md"
(GET_RTX_CLASS (GET_CODE (XEXP (op, 0))) != RTX_AUTOINC));
}
#endif /* tm-constrs.h */
