/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1978 */
rtx
gen_fmssf4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_FMA (SFmode,
	operand1,
	operand2,
	gen_rtx_NEG (SFmode,
	operand3))),
		gen_hard_reg_clobber (CC_FLOATmode, 51)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1991 */
rtx
gen_fnmasf4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_FMA (SFmode,
	gen_rtx_NEG (SFmode,
	operand1),
	operand2,
	operand3)),
		gen_hard_reg_clobber (CC_FLOATmode, 51)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2004 */
rtx
gen_fnmssf4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_FMA (SFmode,
	gen_rtx_NEG (SFmode,
	operand1),
	operand2,
	gen_rtx_NEG (SFmode,
	operand3))),
		gen_hard_reg_clobber (CC_FLOATmode, 51)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2032 */
rtx
gen_return (void)
{
  return ret_rtx;
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2043 */
rtx
gen_return_ret (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		ret_rtx,
		gen_rtx_USE (VOIDmode,
	operand0)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2056 */
rtx
gen_store_movm (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return operand0;
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2085 */
rtx
gen_am33_load_pic (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		const0_rtx),
	2)),
		gen_hard_reg_clobber (CCmode, 51)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2098 */
rtx
gen_mn10300_load_pic0 (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		const0_rtx),
	2)),
		gen_hard_reg_clobber (SImode, 50),
		gen_hard_reg_clobber (CCmode, 51)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2116 */
rtx
gen_mn10300_load_pic1 (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		const0_rtx),
	2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_MEM (SImode,
	gen_rtx_REG (SImode,
	9))),
		gen_hard_reg_clobber (SImode, 50),
		gen_hard_reg_clobber (CCmode, 51)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2135 */
rtx
gen_liw (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (3,
		copy_rtx (operand0),
		operand2,
		operand4),
	8)),
		gen_rtx_SET (operand1,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (3,
		copy_rtx (operand1),
		operand3,
		operand5),
	8))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2154 */
rtx
gen_cmp_liw (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCmode,
	51),
	gen_rtx_COMPARE (CCmode,
	operand2,
	operand3)),
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (3,
		copy_rtx (operand0),
		operand1,
		operand4),
	8))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2169 */
rtx
gen_liw_cmp (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (3,
		copy_rtx (operand0),
		operand1,
		operand4),
	8)),
		gen_rtx_SET (gen_rtx_REG (CCmode,
	51),
	gen_rtx_COMPARE (CCmode,
	operand2,
	operand3))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2191 */
rtx
gen_setlb (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	9);
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2197 */
rtx
gen_Lcc (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		gen_rtx_REG (CCmode,
	51),
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const1_rtx),
	9)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2208 */
rtx
gen_FLcc (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		gen_rtx_REG (CC_FLOATmode,
	51),
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const_int_rtx[MAX_SAVED_CONST_INT + (2)]),
	9)));
}

